diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-phy.cc ns-3.33/src/wifi/model/wifi-phy.cc
--- ns-3.32/src/wifi/model/wifi-phy.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
@@ -29,6 +29,7 @@
 #include "wifi-phy.h"
 #include "ampdu-tag.h"
 #include "wifi-utils.h"
+#include "sta-wifi-mac.h"
 #include "frame-capture-model.h"
 #include "preamble-detection-model.h"
 #include "wifi-radio-energy-model.h"
@@ -38,7 +39,6 @@
 #include "he-configuration.h"
 #include "mpdu-aggregator.h"
 #include "wifi-psdu.h"
-#include "wifi-ppdu.h"
 
 namespace ns3 {
 
@@ -307,7 +307,7 @@
                    UintegerValue (0),
                    MakeUintegerAccessor (&WifiPhy::SetChannelNumber,
                                          &WifiPhy::GetChannelNumber),
-                   MakeUintegerChecker<uint8_t> (0, 196))
+                   MakeUintegerChecker<uint8_t> (0, 233))
     .AddAttribute ("RxSensitivity",
                    "The energy of a received signal should be higher than "
                    "this threshold (dBm) for the PHY to detect the signal.",
@@ -511,6 +511,7 @@
     m_endPreambleDetectionEvent (),
     m_endTxEvent (),
     m_standard (WIFI_PHY_STANDARD_UNSPECIFIED),
+    m_band (WIFI_PHY_BAND_UNSPECIFIED),
     m_isConstructed (false),
     m_channelCenterFrequency (0),
     m_initialFrequency (0),
@@ -1853,7 +1854,8 @@
     case WifiPhyState::SLEEP:
       {
         NS_LOG_DEBUG ("resuming from sleep mode");
-        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW);
+        uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
+        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
         m_state->SwitchFromSleep (delayUntilCcaEnd);
         break;
       }
@@ -1884,7 +1886,8 @@
     case WifiPhyState::OFF:
       {
         NS_LOG_DEBUG ("resuming from off mode");
-        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW);
+        uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
+        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
         m_state->SwitchFromOff (delayUntilCcaEnd);
         break;
       }
@@ -1926,15 +1929,16 @@
   uint8_t Ndltf, Neltf;
   //We suppose here that STBC = 0.
   //If STBC > 0, we need a different mapping between Nss and Nltf (IEEE 802.11n-2012 standard, page 1682).
-  if (txVector.GetNss () < 3)
+  uint8_t nss = txVector.GetNssMax (); //so as to cover also HE MU case (see section 27.3.10.10 of IEEE P802.11ax/D4.0)
+  if (nss < 3)
     {
-      Ndltf = txVector.GetNss ();
+      Ndltf = nss;
     }
-  else if (txVector.GetNss () < 5)
+  else if (nss < 5)
     {
       Ndltf = 4;
     }
-  else if (txVector.GetNss () < 7)
+  else if (nss < 7)
     {
       Ndltf = 6;
     }
@@ -1963,6 +1967,7 @@
       return MicroSeconds (4 + (4 * Ndltf));
     case WIFI_PREAMBLE_HE_SU:
     case WIFI_PREAMBLE_HE_MU:
+    case WIFI_PREAMBLE_HE_TB:
       return MicroSeconds (4 + (8 * Ndltf));
     default:
       return MicroSeconds (0);
@@ -1993,6 +1998,7 @@
     case WIFI_PREAMBLE_HE_SU:
     case WIFI_PREAMBLE_VHT_MU:
     case WIFI_PREAMBLE_HE_MU:
+    case WIFI_PREAMBLE_HE_TB:
       //VHT-SIG-A1 and HE-SIG-A1
       return MicroSeconds (4);
     default:
@@ -2244,18 +2250,19 @@
 }
 
 Time
-WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype)
+WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype, uint16_t staId)
 {
   uint32_t totalAmpduSize;
   double totalAmpduNumSymbols;
-  return GetPayloadDuration (size, txVector, band, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols);
+  return GetPayloadDuration (size, txVector, band, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols, staId);
 }
 
 Time
 WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype,
-                             bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols)
+                             bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
+                             uint16_t staId)
 {
-  WifiMode payloadMode = txVector.GetMode ();
+  WifiMode payloadMode = txVector.GetMode (staId);
   NS_LOG_FUNCTION (size << payloadMode);
 
   double stbc = 1;
@@ -2282,37 +2289,37 @@
   if (payloadMode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
     {
       if (txVector.GetChannelWidth () == 40
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () >= 8)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss () == 2
+          && txVector.GetNss (staId) == 2
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () == 9)
         {
           Nes = 3;
         }
       if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 4)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 3;
@@ -2323,55 +2330,55 @@
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 2
+          && txVector.GetNss (staId) == 2
           && payloadMode.GetMcsValue () >= 4)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 2
+          && txVector.GetNss (staId) == 2
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 3;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () >= 3)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () >= 5)
         {
           Nes = 3;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 3
+          && txVector.GetNss (staId) == 3
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 4;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 2)
         {
           Nes = 2;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 4)
         {
           Nes = 3;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 5)
         {
           Nes = 4;
         }
       if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss () == 4
+          && txVector.GetNss (staId) == 4
           && payloadMode.GetMcsValue () >= 7)
         {
           Nes = 6;
@@ -2424,7 +2431,7 @@
       break;
     }
 
-  double numDataBitsPerSymbol = payloadMode.GetDataRate (txVector) * symbolDuration.GetNanoSeconds () / 1e9;
+  double numDataBitsPerSymbol = payloadMode.GetDataRate (txVector, staId) * symbolDuration.GetNanoSeconds () / 1e9;
 
   double numSymbols = 0;
   if (mpdutype == FIRST_MPDU_IN_AGGREGATE)
@@ -2536,28 +2543,56 @@
 }
 
 Time
-WifiPhy::CalculateTxDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band)
+WifiPhy::CalculateTxDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, uint16_t staId)
 {
   Time duration = CalculatePhyPreambleAndHeaderDuration (txVector)
-    + GetPayloadDuration (size, txVector, band);
+    + GetPayloadDuration (size, txVector, band, NORMAL_MPDU, staId);
+  NS_ASSERT (duration.IsStrictlyPositive ());
   return duration;
 }
 
+Time
+WifiPhy::CalculateTxDuration (WifiConstPsduMap psduMap, WifiTxVector txVector, WifiPhyBand band)
+{
+  Time maxDuration = Seconds (0);
+  for (auto & staIdPsdu : psduMap)
+    {
+      if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+        {
+          WifiTxVector::HeMuUserInfoMap userInfoMap = txVector.GetHeMuUserInfoMap ();
+          NS_ABORT_MSG_IF (userInfoMap.find (staIdPsdu.first) == userInfoMap.end (), "STA-ID in psduMap (" << staIdPsdu.first << ") should be referenced in txVector");
+        }
+      Time current = CalculateTxDuration (staIdPsdu.second->GetSize (), txVector, band, staIdPsdu.first);
+      if (current > maxDuration)
+        {
+          maxDuration = current;
+        }
+    }
+  NS_ASSERT (maxDuration.IsStrictlyPositive ());
+  return maxDuration;
+}
+
 void
-WifiPhy::NotifyTxBegin (Ptr<const WifiPsdu> psdu, double txPowerW)
+WifiPhy::NotifyTxBegin (WifiConstPsduMap psdus, double txPowerW)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  for (auto const& psdu : psdus)
     {
-      m_phyTxBeginTrace (mpdu->GetProtocolDataUnit (), txPowerW);
+      for (auto& mpdu : *PeekPointer (psdu.second))
+        {
+          m_phyTxBeginTrace (mpdu->GetProtocolDataUnit (), txPowerW);
+        }
     }
 }
 
 void
-WifiPhy::NotifyTxEnd (Ptr<const WifiPsdu> psdu)
+WifiPhy::NotifyTxEnd (WifiConstPsduMap psdus)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  for (auto const& psdu : psdus)
     {
-      m_phyTxEndTrace (mpdu->GetProtocolDataUnit ());
+      for (auto& mpdu : *PeekPointer (psdu.second))
+        {
+          m_phyTxEndTrace (mpdu->GetProtocolDataUnit ());
+        }
     }
 }
 
@@ -2571,35 +2606,44 @@
 }
 
 void
-WifiPhy::NotifyRxBegin (Ptr<const WifiPsdu> psdu)
+WifiPhy::NotifyRxBegin (Ptr<const WifiPsdu> psdu, RxPowerWattPerChannelBand rxPowersW)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  if (psdu)
     {
-      m_phyRxBeginTrace (mpdu->GetProtocolDataUnit ());
+      for (auto& mpdu : *PeekPointer (psdu))
+        {
+          m_phyRxBeginTrace (mpdu->GetProtocolDataUnit (), rxPowersW);
+        }
     }
 }
 
 void
 WifiPhy::NotifyRxEnd (Ptr<const WifiPsdu> psdu)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  if (psdu)
     {
-      m_phyRxEndTrace (mpdu->GetProtocolDataUnit ());
+      for (auto& mpdu : *PeekPointer (psdu))
+        {
+          m_phyRxEndTrace (mpdu->GetProtocolDataUnit ());
+        }
     }
 }
 
 void
 WifiPhy::NotifyRxDrop (Ptr<const WifiPsdu> psdu, WifiPhyRxfailureReason reason)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  if (psdu)
     {
-      m_phyRxDropTrace (mpdu->GetProtocolDataUnit (), reason);
+      for (auto& mpdu : *PeekPointer (psdu))
+        {
+          m_phyRxDropTrace (mpdu->GetProtocolDataUnit (), reason);
+        }
     }
 }
 
 void
 WifiPhy::NotifyMonitorSniffRx (Ptr<const WifiPsdu> psdu, uint16_t channelFreqMhz, WifiTxVector txVector,
-                               SignalNoiseDbm signalNoise, std::vector<bool> statusPerMpdu)
+                               SignalNoiseDbm signalNoise, std::vector<bool> statusPerMpdu, uint16_t staId)
 {
   MpduInfo aMpdu;
   if (psdu->IsAggregate ())
@@ -2609,12 +2653,12 @@
       aMpdu.mpduRefNumber = ++m_rxMpduReferenceNumber;
       size_t nMpdus = psdu->GetNMpdus ();
       NS_ASSERT_MSG (statusPerMpdu.size () == nMpdus, "Should have one reception status per MPDU");
-      aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU: FIRST_MPDU_IN_AGGREGATE;
+      aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU : FIRST_MPDU_IN_AGGREGATE;
       for (size_t i = 0; i < nMpdus;)
         {
           if (statusPerMpdu.at (i)) //packet received without error, hand over to sniffer
             {
-              m_phyMonitorSniffRxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, signalNoise);
+              m_phyMonitorSniffRxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
             }
           ++i;
           aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
@@ -2624,12 +2668,12 @@
     {
       aMpdu.type = NORMAL_MPDU;
       NS_ASSERT_MSG (statusPerMpdu.size () == 1, "Should have one reception status for normal MPDU");
-      m_phyMonitorSniffRxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, signalNoise);
+      m_phyMonitorSniffRxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
     }
 }
 
 void
-WifiPhy::NotifyMonitorSniffTx (Ptr<const WifiPsdu> psdu, uint16_t channelFreqMhz, WifiTxVector txVector)
+WifiPhy::NotifyMonitorSniffTx (Ptr<const WifiPsdu> psdu, uint16_t channelFreqMhz, WifiTxVector txVector, uint16_t staId)
 {
   MpduInfo aMpdu;
   if (psdu->IsAggregate ())
@@ -2641,7 +2685,7 @@
       aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU: FIRST_MPDU_IN_AGGREGATE;
       for (size_t i = 0; i < nMpdus;)
         {
-          m_phyMonitorSniffTxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu);
+          m_phyMonitorSniffTxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, staId);
           ++i;
           aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
         }
@@ -2649,7 +2693,7 @@
   else
     {
       aMpdu.type = NORMAL_MPDU;
-      m_phyMonitorSniffTxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu);
+      m_phyMonitorSniffTxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, staId);
     }
 }
 
@@ -2663,6 +2707,15 @@
 WifiPhy::Send (Ptr<const WifiPsdu> psdu, WifiTxVector txVector)
 {
   NS_LOG_FUNCTION (this << *psdu << txVector);
+  WifiConstPsduMap psdus;
+  psdus.insert (std::make_pair (SU_STA_ID, psdu));
+  Send (psdus, txVector);
+}
+
+void
+WifiPhy::Send (WifiConstPsduMap psdus, WifiTxVector txVector)
+{
+  NS_LOG_FUNCTION (this << psdus << txVector);
   /* Transmission can happen if:
    *  - we are syncing on a packet. It is the responsibility of the
    *    MAC layer to avoid doing this but the PHY does nothing to
@@ -2672,7 +2725,7 @@
   NS_ASSERT (!m_state->IsStateTx () && !m_state->IsStateSwitching ());
   NS_ASSERT (m_endTxEvent.IsExpired ());
 
-  if (txVector.GetNss () > GetMaxSupportedTxSpatialStreams ())
+  if (txVector.GetNssMax () > GetMaxSupportedTxSpatialStreams ())
     {
       NS_FATAL_ERROR ("Unsupported number of spatial streams!");
     }
@@ -2680,12 +2733,14 @@
   if (m_state->IsStateSleep ())
     {
       NS_LOG_DEBUG ("Dropping packet because in sleep mode");
-      NotifyTxDrop (psdu);
+      for (auto const& psdu : psdus)
+        {
+          NotifyTxDrop (psdu.second);
+        }
       return;
     }
 
-  Time txDuration = CalculateTxDuration (psdu->GetSize (), txVector, GetPhyBand ());
-  NS_ASSERT (txDuration.IsStrictlyPositive ());
+  Time txDuration = CalculateTxDuration (psdus, txVector, GetPhyBand ());
 
   if ((m_currentEvent != 0) && (m_currentEvent->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ())))
     {
@@ -2714,19 +2769,22 @@
     }
 
   double txPowerW = DbmToW (GetTxPowerForTransmission (txVector) + GetTxGain ());
-  NotifyTxBegin (psdu, txPowerW);
-  m_phyTxPsduBeginTrace (psdu, txVector, txPowerW);
-  NotifyMonitorSniffTx (psdu, GetFrequency (), txVector);
-  m_state->SwitchToTx (txDuration, psdu->GetPacket (), GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
+  NotifyTxBegin (psdus, txPowerW);
+  m_phyTxPsduBeginTrace (psdus, txVector, txPowerW);
+  for (auto const& psdu : psdus)
+    {
+      NotifyMonitorSniffTx (psdu.second, GetFrequency (), txVector, psdu.first);
+    }
+  m_state->SwitchToTx (txDuration, psdus, GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
 
-  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, GetPhyBand ());
+  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdus, txVector, txDuration, GetPhyBand ());
 
   if (m_wifiRadioEnergyModel != 0 && m_wifiRadioEnergyModel->GetMaximumTimeInState (WifiPhyState::TX) < txDuration)
     {
       ppdu->SetTruncatedTx ();
     }
 
-  m_endTxEvent = Simulator::Schedule (txDuration, &WifiPhy::NotifyTxEnd, this, psdu);
+  m_endTxEvent = Simulator::Schedule (txDuration, &WifiPhy::NotifyTxEnd, this, psdus); //TODO: fix for MU
 
   StartTx (ppdu);
 
@@ -2744,18 +2802,28 @@
   NS_ASSERT (event->GetStartTime () == m_currentEvent->GetStartTime ());
   NS_ASSERT (event->GetEndTime () == m_currentEvent->GetEndTime ());
 
-  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event);
+  uint16_t channelWidth;
+  if (event->GetTxVector ().GetChannelWidth () >= 40)
+    {
+      channelWidth = 20; //calculate PER on the 20 MHz primary channel for PHY headers
+    }
+  else
+    {
+      channelWidth = event->GetTxVector ().GetChannelWidth ();
+    }
+  auto band = GetBand (channelWidth);
+  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event, band);
   double snr = snrPer.snr;
   NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
 
-  if (!m_preambleDetectionModel || (m_preambleDetectionModel->IsPreambleDetected (event->GetRxPowerW (), snr, m_channelWidth)))
+  if (!m_preambleDetectionModel || (m_preambleDetectionModel->IsPreambleDetected (event->GetRxPowerW (band), snr, m_channelWidth)))
     {
-      NotifyRxBegin (event->GetPsdu ());
+      NotifyRxBegin (GetAddressedPsduInPpdu (event->GetPpdu ()), event->GetRxPowerWPerBand ());
 
       m_timeLastPreambleDetected = Simulator::Now ();
       WifiTxVector txVector = event->GetTxVector ();
 
-      if ((txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HT) && (txVector.GetPreambleType () == WIFI_PREAMBLE_HT_GF))
+      if (txVector.GetPreambleType () == WIFI_PREAMBLE_HT_GF)
         {
           //No non-HT PHY header for HT GF
           Time remainingPreambleHeaderDuration = CalculatePhyPreambleAndHeaderDuration (txVector) - GetPreambleDetectionDuration ();
@@ -2773,7 +2841,7 @@
   else
     {
       NS_LOG_DEBUG ("Drop packet because PHY preamble detection failed");
-      NotifyRxDrop (event->GetPsdu (), PREAMBLE_DETECT_FAILURE);
+      NotifyRxDrop (GetAddressedPsduInPpdu (event->GetPpdu ()), PREAMBLE_DETECT_FAILURE);
       m_interference.NotifyRxEnd ();
       m_currentEvent = 0;
 
@@ -2792,9 +2860,18 @@
   NS_LOG_FUNCTION (this << *event);
   NS_ASSERT (m_endPhyRxEvent.IsExpired ());
 
-  InterferenceHelper::SnrPer snrPer;
-  snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event);
+  uint16_t channelWidth;
+  if (event->GetTxVector ().GetChannelWidth () >= 40)
+    {
+      channelWidth = 20; //calculate PER on the 20 MHz primary channel for PHY headers
+    }
+  else
+    {
+      channelWidth = event->GetTxVector ().GetChannelWidth ();
+    }
+  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event, GetBand (channelWidth));
 
+  NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
   if (m_random->GetValue () > snrPer.per) //non-HT PHY header reception succeeded
     {
       NS_LOG_DEBUG ("Received non-HT PHY header");
@@ -2816,13 +2893,17 @@
 }
 
 void
-WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, double rxPowerW)
+WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW)
 {
-  NS_LOG_FUNCTION (this << *ppdu << rxPowerW);
+  //The total RX power corresponds to the maximum over all the bands
+  auto it = std::max_element (rxPowersW.begin (), rxPowersW.end (),
+    [] (const std::pair<WifiSpectrumBand, double>& p1, const std::pair<WifiSpectrumBand, double>& p2) {
+      return p1.second < p2.second;
+    });
+  NS_LOG_FUNCTION (this << *ppdu << it->second);
   WifiTxVector txVector = ppdu->GetTxVector ();
   Time rxDuration = ppdu->GetTxDuration ();
-  Ptr<const WifiPsdu> psdu = ppdu->GetPsdu ();
-  Ptr<Event> event = m_interference.Add (ppdu, txVector, rxDuration, rxPowerW);
+  Ptr<Event> event = m_interference.Add (ppdu, txVector, rxDuration, rxPowersW);
   Time endRx = Simulator::Now () + rxDuration;
 
   if (m_state->GetState () == WifiPhyState::OFF)
@@ -2849,7 +2930,7 @@
     {
       //If SetRate method was not called above when filling in txVector, this means the PHY does support the rate indicated in PHY SIG headers
       NS_LOG_DEBUG ("drop packet because of unsupported RX mode");
-      NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
+      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), UNSUPPORTED_SETTINGS);
       if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
           MaybeCcaBusyDuration ();
@@ -2861,7 +2942,7 @@
     {
     case WifiPhyState::SWITCHING:
       NS_LOG_DEBUG ("drop packet because of channel switching");
-      NotifyRxDrop (psdu, CHANNEL_SWITCHING);
+      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), CHANNEL_SWITCHING);
       /*
        * Packets received on the upcoming channel are added to the event list
        * during the switching state. This way the medium can be correctly sensed
@@ -2884,13 +2965,12 @@
         {
           AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
           NS_LOG_DEBUG ("Switch to new packet");
-          StartRx (event, rxPowerW);
+          StartRx (event);
         }
       else
         {
-          NS_LOG_DEBUG ("Drop packet because already in Rx (power=" <<
-                        rxPowerW << "W)");
-          NotifyRxDrop (psdu, RXING);
+          NS_LOG_DEBUG ("Drop packet because already in Rx");
+          NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), RXING);
           if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
             {
               //that packet will be noise _after_ the reception of the currently-received packet.
@@ -2899,9 +2979,8 @@
         }
       break;
     case WifiPhyState::TX:
-      NS_LOG_DEBUG ("Drop packet because already in Tx (power=" <<
-                    rxPowerW << "W)");
-      NotifyRxDrop (psdu, TXING);
+      NS_LOG_DEBUG ("Drop packet because already in Tx");
+      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), TXING);
       if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
           //that packet will be noise _after_ the transmission of the currently-transmitted packet.
@@ -2917,13 +2996,12 @@
             {
               AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
               NS_LOG_DEBUG ("Switch to new packet");
-              StartRx (event, rxPowerW);
+              StartRx (event);
             }
           else
             {
-              NS_LOG_DEBUG ("Drop packet because already in Rx (power=" <<
-                            rxPowerW << "W)");
-              NotifyRxDrop (psdu, RXING);
+              NS_LOG_DEBUG ("Drop packet because already in Rx");
+              NotifyRxDrop (ppdu->GetPsdu (), RXING);
               if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
                 {
                   //that packet will be noise _after_ the reception of the currently-received packet.
@@ -2933,15 +3011,15 @@
         }
       else
         {
-          StartRx (event, rxPowerW);
+          StartRx (event);
         }
       break;
     case WifiPhyState::IDLE:
-      StartRx (event, rxPowerW);
+      StartRx (event);
       break;
     case WifiPhyState::SLEEP:
       NS_LOG_DEBUG ("Drop packet because in sleep mode");
-      NotifyRxDrop (psdu, SLEEPING);
+      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), SLEEPING);
       if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
           //that packet will be noise _after_ the sleep period.
@@ -2961,8 +3039,8 @@
   //not going to be able to synchronize on it
   //In this model, CCA becomes busy when the aggregation of all signals as
   //tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
-
-  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW);
+  uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
+  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
   if (!delayUntilCcaEnd.IsZero ())
     {
       m_state->SwitchMaybeToCcaBusy (delayUntilCcaEnd);
@@ -2975,13 +3053,15 @@
   NS_LOG_FUNCTION (this << *event);
   NS_ASSERT (m_endPhyRxEvent.IsExpired ());
   NS_ASSERT (m_endRxEvent.IsExpired ());
-  WifiTxVector txVector = event->GetTxVector ();
-  WifiMode txMode = txVector.GetMode ();
-  bool canReceivePayload;
-  if (txMode.GetModulationClass () >= WIFI_MOD_CLASS_HT)
+  bool canReceivePayload = false;
+  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
+  WifiModulationClass modulation = ppdu->GetModulation ();
+  //calculate PER on the primary 20 MHz channel for PHY headers
+  uint16_t primaryChannelWidth = std::min (event->GetTxVector ().GetChannelWidth (), static_cast<uint16_t> (20));
+  auto primaryBand = GetBand (primaryChannelWidth);
+  if (modulation >= WIFI_MOD_CLASS_HT)
     {
-      InterferenceHelper::SnrPer snrPer;
-      snrPer = m_interference.CalculateHtPhyHeaderSnrPer (event);
+      InterferenceHelper::SnrPer snrPer = m_interference.CalculateHtPhyHeaderSnrPer (event, primaryBand);
       NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
       canReceivePayload = (m_random->GetValue () > snrPer.per);
     }
@@ -2990,51 +3070,92 @@
       //If we are here, this means non-HT PHY header was already successfully received
       canReceivePayload = true;
     }
+  WifiTxVector txVector = event->GetTxVector ();
   Time payloadDuration = event->GetEndTime () - event->GetStartTime () - CalculatePhyPreambleAndHeaderDuration (txVector);
+  bool success = false;
   if (canReceivePayload) //PHY reception succeeded
     {
-      if (txVector.GetNss () > GetMaxSupportedRxSpatialStreams ())
+      Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu (ppdu);
+      if (psdu)
         {
-          NS_LOG_DEBUG ("Packet reception could not be started because not enough RX antennas");
-          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+          WifiMode txMode = txVector.GetMode (GetStaId ());
+          uint8_t nss = txVector.GetNssMax();
+          if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+            {
+              uint16_t staId = GetStaId ();
+              for (const auto & info : txVector.GetHeMuUserInfoMap ())
+                {
+                  if (info.first == staId)
+                    {
+                      nss = info.second.nss; //no need to look at other PSDUs
+                      break;
+                    }
+                }
+            }
+          if (nss > GetMaxSupportedRxSpatialStreams ())
+            {
+              NS_LOG_DEBUG ("Packet reception could not be started because not enough RX antennas");
+              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
+            }
+          else if ((txVector.GetChannelWidth () >= 40) && (txVector.GetChannelWidth () > GetChannelWidth ()))
+            {
+              NS_LOG_DEBUG ("Packet reception could not be started because not enough channel width");
+              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
+            }
+          else if (IsModeSupported (txMode) || IsMcsSupported (txMode))
+            {
+              m_statusPerMpdu.clear();
+              if (psdu->GetNMpdus () > 1)
+                {
+                  ScheduleEndOfMpdus (event);
+                }
+              m_state->SwitchToRx (payloadDuration);
+              m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is triggered only if headers have been correctly decoded and that the mode within is supported
+              m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::EndReceive, this, event);
+              success = true;
+              NS_LOG_DEBUG ("Receiving PSDU");
+            }
+          else //mode is not allowed
+            {
+              NS_LOG_DEBUG ("Drop packet because it was sent using an unsupported mode (" << txMode << ")");
+              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
+            }
         }
-      else if ((txVector.GetChannelWidth () >= 40) && (txVector.GetChannelWidth () > GetChannelWidth ()))
+      else
         {
-          NS_LOG_DEBUG ("Packet reception could not be started because not enough channel width");
-          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+          NS_ASSERT (ppdu->IsMu ());
+          NS_LOG_DEBUG ("No PSDU addressed to that PHY in the received MU PPDU. The PPDU is filtered.");
+          payloadDuration = NanoSeconds (0); //so as to call AbortCurrentReception below
+          m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is also triggered for filtered PPDUs
+        }
+      if (modulation == WIFI_MOD_CLASS_HE)
+        {
+          HePreambleParameters params;
+          params.rssiW = event->GetRxPowerW (primaryBand);
+          params.bssColor = event->GetTxVector ().GetBssColor ();
+          NotifyEndOfHePreamble (params);
         }
-      else if (!IsModeSupported (txMode) && !IsMcsSupported (txMode))
+    }
+  else //PHY reception failed
+    {
+      NS_LOG_DEBUG ("Drop packet because HT PHY header reception failed");
+      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), SIG_A_FAILURE);
+    }
+  if (!success)
+    {
+      if (payloadDuration.IsStrictlyPositive ())
         {
-          NS_LOG_DEBUG ("Drop packet because it was sent using an unsupported mode (" << txMode << ")");
-          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+          m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::ResetReceive, this, event);
         }
       else
         {
-          m_statusPerMpdu.clear();
-          if (event->GetPsdu ()->GetNMpdus () > 1)
+          AbortCurrentReception (FILTERED); //immediately followed by PHY-RXEND (Filtered)
+          if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
             {
-              ScheduleEndOfMpdus (event);
-            }
-          m_state->SwitchToRx (payloadDuration);
-          m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::EndReceive, this, event);
-          NS_LOG_DEBUG ("Receiving PSDU");
-          m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is triggered only if headers have been correctly decoded and that the mode within is supported
-          if (txMode.GetModulationClass () == WIFI_MOD_CLASS_HE)
-            {
-              HePreambleParameters params;
-              params.rssiW = event->GetRxPowerW ();
-              params.bssColor = event->GetTxVector ().GetBssColor ();
-              NotifyEndOfHePreamble (params);
+              MaybeCcaBusyDuration ();
             }
-          return;
         }
     }
-  else //PHY reception failed
-    {
-      NS_LOG_DEBUG ("Drop packet because HT PHY header reception failed");
-      NotifyRxDrop (event->GetPsdu (), SIG_A_FAILURE);
-    }
-  m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::ResetReceive, this, event);
 }
 
 void
